Overview | Package | Class | Use | Tree | Deprecated | Index | Help
| HTML Parser Home Page
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## org.htmlparser.lexer
Class Page

    java.lang.Object
      org.htmlparser.lexer.Page

All Implemented Interfaces:
  Serializable

    public class Page

extends Object
implements Serializable

Represents the contents of an HTML page. Contains the source of characters and an index of positions of line separators (actually the first character position on the next line).

See Also:
  Serialized Form

Field Summary
`static String` | `DEFAULT_CHARSET` The default charset.
`static String` | `DEFAULT_CONTENT_TYPE` The default content type.
`static char` | `EOF` Character value when the page is exhausted.
`protected String` | `mBaseUrl` The base URL for this page.
`protected URLConnection` | `mConnection` The connection this page is coming from or `null`.
`protected static ConnectionManager` | `mConnectionManager` Connection control (proxy, cookies, authorization).
`protected PageIndex` | `mIndex` Character positions of the first character in each line.
`protected Source` | `mSource` The source of characters.
`protected String` | `mUrl` The URL this page is coming from.

Constructor Summary
`Page()` Construct an empty page.
`Page(InputStream stream, String charset)` Construct a page from a stream encoded with the given charset.
`Page(Source source)` Construct a page from a source.
`Page(String text)` Construct a page from the given string.
`Page(String text, String charset)` Construct a page from the given string.
`Page(URLConnection connection)` Construct a page reading from a URL connection.

Method Summary
`void` | `close()` Close the page by destroying the source of characters.
`int` | `column(Cursor cursor)` Get the column number for a cursor.
`int` | `column(int position)` Get the column number for a cursor.
`URL` | `constructUrl(String link, String base)` Build a URL from the link and base provided using non-strict rules.
`URL` | `constructUrl(String link, String base, boolean strict)` Build a URL from the link and base provided.
`protected void` | `finalize()` Clean up this page, releasing resources.
`static String` | `findCharset(String name, String fallback)` Lookup a character set name.
`String` | `getAbsoluteURL(String link)` Create an absolute URL from a relative link.
`String` | `getAbsoluteURL(String link, boolean strict)` Create an absolute URL from a relative link.
`String` | `getBaseUrl()` Gets the baseUrl.
`char` | `getCharacter(Cursor cursor)` Read the character at the given cursor position.
`String` | `getCharset(String content)` Get a CharacterSet name corresponding to a charset parameter.
`URLConnection` | `getConnection()` Get the connection, if any.
`static ConnectionManager` | `getConnectionManager()` Get the connection manager all Parsers use.
`String` | `getContentType()` Try and extract the content type from the HTTP header.
`String` | `getEncoding()` Get the current encoding being used.
`String` | `getLine(Cursor cursor)` Get the text line the position of the cursor lies on.
`String` | `getLine(int position)` Get the text line the position of the cursor lies on.
`Source` | `getSource()` Get the source this page is reading from.
`String` | `getText()` Get all text read so far from the source.
`void` | `getText(char[] array, int offset, int start, int end)` Put the text identified by the given limits into the given array at the specified offset.
`String` | `getText(int start, int end)` Get the text identified by the given limits.
`void` | `getText(StringBuffer buffer)` Put all text read so far from the source into the given buffer.
`void` | `getText(StringBuffer buffer, int start, int end)` Put the text identified by the given limits into the given buffer.
`String` | `getUrl()` Get the URL for this page.
`void` | `reset()` Reset the page by resetting the source of characters.
`int` | `row(Cursor cursor)` Get the line number for a cursor.
`int` | `row(int position)` Get the line number for a cursor.
`void` | `setBaseUrl(String url)` Sets the baseUrl.
`void` | `setConnection(URLConnection connection)` Set the URLConnection to be used by this page.
`static void` | `setConnectionManager(ConnectionManager manager)` Set the connection manager to use.
`void` | `setEncoding(String character_set)` Begins reading from the source with the given character set.
`void` | `setUrl(String url)` Set the URL for this page.
`String` | `toString()` Display some of this page as a string.
`void` | `ungetCharacter(Cursor cursor)` Return a character.

Methods inherited from class java.lang.Object
`clone, equals, getClass, hashCode, notify, notifyAll, wait, wait, wait`

Field Detail

### DEFAULT_CHARSET

    public static final String DEFAULT_CHARSET

  The default charset. This should be `"ISO-8859-1"`, see RFC 2616 (http://www.ietf.org/rfc/rfc2616.txt?number=2616) section 3.7.1

  Another alias is "8859_1".

  See Also:
    Constant Field Values

### DEFAULT_CONTENT_TYPE

    public static final String DEFAULT_CONTENT_TYPE

  The default content type. In the absence of alternate information, assume html content ("text/html").

  See Also:
    Constant Field Values

### EOF

    public static final char EOF

  Character value when the page is exhausted. Has a value of 65535.

  See Also:
    Constant Field Values

### mUrl

    protected String mUrl

  The URL this page is coming from. Cached value of `getConnection().toExternalForm()` or `setUrl()`.

### mBaseUrl

    protected String mBaseUrl

  The base URL for this page.

### mSource

    protected Source mSource

  The source of characters.

### mIndex

    protected PageIndex mIndex

  Character positions of the first character in each line.

### mConnection

    protected transient URLConnection mConnection

  The connection this page is coming from or `null`.

### mConnectionManager

    protected static ConnectionManager mConnectionManager

  Connection control (proxy, cookies, authorization).

Constructor Detail

### Page

    public Page()

  Construct an empty page.

### Page

    public Page(URLConnection connection)
         throws ParserException

  Construct a page reading from a URL connection.

  Parameters:
    `connection` - A fully conditioned connection. The connect() method will be called so it need not be connected yet.
  Throws:
    `ParserException` - An exception object wrapping a number of possible error conditions, some of which are outlined below.
    - IOException If an i/o exception occurs creating the source.
    - UnsupportedEncodingException if the character set specified in the HTTP header is not supported.

### Page

    public Page(InputStream stream,
                String charset)
         throws UnsupportedEncodingException

  Construct a page from a stream encoded with the given charset.

  Parameters:
    `stream` - The source of bytes.
    `charset` - The encoding used. If null, defaults to the `DEFAULT_CHARSET`.
  Throws:
    `UnsupportedEncodingException` - If the given charset is not supported.

### Page

    public Page(String text,
                String charset)

  Construct a page from the given string.

  Parameters:
    `text` - The HTML text.
    `charset` - Optional. The character set encoding that will be reported by `getEncoding()`. If charset is `null` the default character set is used.

### Page

    public Page(String text)

  Construct a page from the given string. The page will report that it is using an encoding of `DEFAULT_CHARSET`.

  Parameters:
    `text` - The HTML text.

### Page

    public Page(Source source)

  Construct a page from a source.

  Parameters:
    `source` - The source of characters.

Method Detail

### getConnectionManager

    public static ConnectionManager getConnectionManager()

  Get the connection manager all Parsers use.

  Returns:
    The connection manager.

### setConnectionManager

    public static void setConnectionManager(ConnectionManager manager)

  Set the connection manager to use.

  Parameters:
    `manager` - The new connection manager.

### getCharset

    public String getCharset(String content)

  Get a CharacterSet name corresponding to a charset parameter.

  Parameters:
    `content` - A text line of the form:

         text/html; charset=Shift_JIS

    which is applicable both to the HTTP header field Content-Type and the meta tag http-equiv="Content-Type". Note this method also handles non-compliant quoted charset directives such as:

         text/html; charset="UTF-8"

    and

         text/html; charset='UTF-8'

  Returns:
    The character set name to use when reading the input stream. For JDKs that have the Charset class this is qualified by passing the name to findCharset() to render it into canonical form. If the charset parameter is not found in the given string, the default character set is returned.
  See Also:
    `findCharset(java.lang.String, java.lang.String)`, `DEFAULT_CHARSET`

### findCharset

    public static String findCharset(String name,
                                     String fallback)

  Lookup a character set name. Vacuous for JVM's without `java.nio.charset`. This uses reflection so the code will still run under prior JDK's but in that case the default is always returned.

  Parameters:
    `name` - The name to look up. One of the aliases for a character set.
    `fallback` - The name to return if the lookup fails.
  Returns:
    The character set name.

### reset

    public void reset()

  Reset the page by resetting the source of characters.

### close

    public void close()
               throws IOException

  Close the page by destroying the source of characters.

  Throws:
    `IOException` - If destroying the source encounters an error.

### finalize

    protected void finalize()
                     throws Throwable

  Clean up this page, releasing resources. Calls `close()`.

  Overrides:
    `finalize` in class `Object`
  Throws:
    `Throwable` - if `close()` throws an `IOException`.

### getConnection

    public URLConnection getConnection()

  Get the connection, if any.

  Returns:
    The connection object for this page, or null if this page is built from a stream or a string.

### setConnection

    public void setConnection(URLConnection connection)
                       throws ParserException

  Set the URLConnection to be used by this page. Starts reading from the given connection. This also resets the current url.

  Parameters:
    `connection` - The connection to use. It will be connected by this method.
  Throws:
    `ParserException` - If the `connect()` method fails, or an I/O error occurs opening the input stream or the character set designated in the HTTP header is unsupported.

### getUrl

    public String getUrl()

  Get the URL for this page. This is only available if the page has a connection (`getConnection()` returns non-null), or the document base has been set via a call to `setUrl()`.

  Returns:
    The url for the connection, or `null` if there is no conenction or the document base has not been set.

### setUrl

    public void setUrl(String url)

  Set the URL for this page. This doesn't affect the contents of the page, just the interpretation of relative links from this point forward.

  Parameters:
    `url` - The new URL.

### getBaseUrl

    public String getBaseUrl()

  Gets the baseUrl.

  Returns:
    The base URL for this page, or `null` if not set.

### setBaseUrl

    public void setBaseUrl(String url)

  Sets the baseUrl.

  Parameters:
    `url` - The base url for this page.

### getSource

    public Source getSource()

  Get the source this page is reading from.

  Returns:
    The current source.

### getContentType

    public String getContentType()

  Try and extract the content type from the HTTP header.

  Returns:
    The content type.

### getCharacter

    public char getCharacter(Cursor cursor)
                      throws ParserException

  Read the character at the given cursor position. The cursor position can be only behind or equal to the current source position. Returns end of lines (EOL) as \n, by converting \r and \r\n to \n, and updates the end-of-line index accordingly. Advances the cursor position by one (or two in the \r\n case).

  Parameters:
    `cursor` - The position to read at.
  Returns:
    The character at that position, and modifies the cursor to prepare for the next read. If the source is exhausted a zero is returned.
  Throws:
    `ParserException` - If an IOException on the underlying source occurs, or an attempt is made to read characters in the future (the cursor position is ahead of the underlying stream)

### ungetCharacter

    public void ungetCharacter(Cursor cursor)
                        throws ParserException

  Return a character. Handles end of lines (EOL) specially, retreating the cursor twice for the '\r\n' case. The cursor position is moved back by one (or two in the \r\n case).

  Parameters:
    `cursor` - The position to 'unread' at.
  Throws:
    `ParserException` - If an IOException on the underlying source occurs.

### getEncoding

    public String getEncoding()

  Get the current encoding being used.

  Returns:
    The encoding used to convert characters.

### setEncoding

    public void setEncoding(String character_set)
                     throws ParserException

  Begins reading from the source with the given character set. If the current encoding is the same as the requested encoding, this method is a no-op. Otherwise any subsequent characters read from this page will have been decoded using the given character set.

  Some magic happens here to obtain this result if characters have already been consumed from this page. Since a Reader cannot be dynamically altered to use a different character set, the underlying stream is reset, a new Source is constructed and a comparison made of the characters read so far with the newly read characters up to the current position. If a difference is encountered, or some other problem occurs, an exception is thrown.

  Parameters:
    `character_set` - The character set to use to convert bytes into characters.
  Throws:
    `ParserException` - If a character mismatch occurs between characters already provided and those that would have been returned had the new character set been in effect from the beginning. An exception is also thrown if the underlying stream won't put up with these shenanigans.

### constructUrl

    public URL constructUrl(String link,
                            String base)
                     throws MalformedURLException

  Build a URL from the link and base provided using non-strict rules.

  Parameters:
    `link` - The (relative) URI.
    `base` - The base URL of the page, either from the <BASE> tag or, if none, the URL the page is being fetched from.
  Returns:
    An absolute URL.
  Throws:
    `MalformedURLException` - If creating the URL fails.
  See Also:
    `constructUrl(String, String, boolean)`

### constructUrl

    public URL constructUrl(String link,
                            String base,
                            boolean strict)
                     throws MalformedURLException

  Build a URL from the link and base provided.

  Parameters:
    `link` - The (relative) URI.
    `base` - The base URL of the page, either from the <BASE> tag or, if none, the URL the page is being fetched from.
    `strict` - If `true` a link starting with '?' is handled according to RFC 2396, otherwise the common interpretation of a query appended to the base is used instead.
  Returns:
    An absolute URL.
  Throws:
    `MalformedURLException` - If creating the URL fails.

### getAbsoluteURL

    public String getAbsoluteURL(String link)

  Create an absolute URL from a relative link.

  Parameters:
    `link` - The reslative portion of a URL.
  Returns:
    The fully qualified URL or the original link if it was absolute already or a failure occured.

### getAbsoluteURL

    public String getAbsoluteURL(String link,
                                 boolean strict)

  Create an absolute URL from a relative link.

  Parameters:
    `link` - The reslative portion of a URL.
    `strict` - If `true` a link starting with '?' is handled according to RFC 2396, otherwise the common interpretation of a query appended to the base is used instead.
  Returns:
    The fully qualified URL or the original link if it was absolute already or a failure occured.

### row

    public int row(Cursor cursor)

  Get the line number for a cursor.

  Parameters:
    `cursor` - The character offset into the page.
  Returns:
    The line number the character is in.

### row

    public int row(int position)

  Get the line number for a cursor.

  Parameters:
    `position` - The character offset into the page.
  Returns:
    The line number the character is in.

### column

    public int column(Cursor cursor)

  Get the column number for a cursor.

  Parameters:
    `cursor` - The character offset into the page.
  Returns:
    The character offset into the line this cursor is on.

### column

    public int column(int position)

  Get the column number for a cursor.

  Parameters:
    `position` - The character offset into the page.
  Returns:
    The character offset into the line this cursor is on.

### getText

    public String getText(int start,
                          int end)
                   throws IllegalArgumentException

  Get the text identified by the given limits.

  Parameters:
    `start` - The starting position, zero based.
    `end` - The ending position (exclusive, i.e. the character at the ending position is not included), zero based.
  Returns:
    The text from `start` to `end`.
  Throws:
    `IllegalArgumentException` - If an attempt is made to get characters ahead of the current source offset (character position).
  See Also:
    `getText(StringBuffer, int, int)`

### getText

    public void getText(StringBuffer buffer,
                        int start,
                        int end)
                 throws IllegalArgumentException

  Put the text identified by the given limits into the given buffer.

  Parameters:
    `buffer` - The accumulator for the characters.
    `start` - The starting position, zero based.
    `end` - The ending position (exclusive, i.e. the character at the ending position is not included), zero based.
  Throws:
    `IllegalArgumentException` - If an attempt is made to get characters ahead of the current source offset (character position).

### getText

    public String getText()

  Get all text read so far from the source.

  Returns:
    The text from the source.
  See Also:
    `getText(StringBuffer)`

### getText

    public void getText(StringBuffer buffer)

  Put all text read so far from the source into the given buffer.

  Parameters:
    `buffer` - The accumulator for the characters.
  See Also:
    `getText(StringBuffer,int,int)`

### getText

    public void getText(char[] array,
                        int offset,
                        int start,
                        int end)
                 throws IllegalArgumentException

  Put the text identified by the given limits into the given array at the specified offset.

  Parameters:
    `array` - The array of characters.
    `offset` - The starting position in the array where characters are to be placed.
    `start` - The starting position, zero based.
    `end` - The ending position (exclusive, i.e. the character at the ending position is not included), zero based.
  Throws:
    `IllegalArgumentException` - If an attempt is made to get characters ahead of the current source offset (character position).

### getLine

    public String getLine(Cursor cursor)

  Get the text line the position of the cursor lies on.

  Parameters:
    `cursor` - The position to calculate for.
  Returns:
    The contents of the URL or file corresponding to the line number containing the cursor position.

### getLine

    public String getLine(int position)

  Get the text line the position of the cursor lies on.

  Parameters:
    `position` - The position to calculate for.
  Returns:
    The contents of the URL or file corresponding to the line number containg the cursor position.

### toString

    public String toString()

  Display some of this page as a string.

  Overrides:
    `toString` in class `Object`
  Returns:
    The last few characters the source read in.

Overview | Package | Class | Use | Tree | Deprecated | Index | Help
| © 2005 Derrick Oswald Jun 10, 2006
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

HTML Parser is an open source library released under LGPL. |